//this source code was auto-generated by tolua#, do not modify it
using System;
using System.Collections.Generic;
using LuaInterface;

public class CLASSTAG_Map2DWrap
{
    public static void Register(LuaState L)
    {
        L.BeginClass(typeof(Map2D), typeof(System.Object));
        L.RegFunction("LoadAsync",FUNCTAG_LoadAsync);
        L.RegFunction("Load",FUNCTAG_Load);
        L.RegFunction("GetTransfer",FUNCTAG_GetTransfer);
        L.RegFunction("GetTransferEffectParent",FUNCTAG_GetTransferEffectParent);
        L.RegFunction("Release",FUNCTAG_Release);
        L.RegVar("width",FUNCTAG_get_width, null);
        L.RegVar("height",FUNCTAG_get_height, null);
        L.RegVar("xTile",FUNCTAG_get_xGrid, null);
        L.RegVar("yTile",FUNCTAG_get_yGrid, null);
        L.EndClass();
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_LoadAsync(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 4);
            Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
            int mapid = (int)LuaDLL.lua_tonumber(L, 2);
            UnityEngine.Vector3 arg0 = ToLua.ToVector3(L, 3);
            LuaFunction func = ToLua.ToLuaFunction(L, 4);
            obj.LoadAsync(mapid, arg0, func);
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_Load(IntPtr L)
    {
        try
        {	
			int count = LuaDLL.lua_gettop(L);
			if (count == 4 && TypeChecker.CheckTypes(L, 1, typeof(Map2D), typeof(int), typeof(int), typeof(UnityEngine.Vector3)))
			{
				Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
				int mapid = (int)LuaDLL.lua_tonumber(L, 2);
				int navid = (int)LuaDLL.lua_tonumber(L, 3);
				UnityEngine.Vector3 arg0 = ToLua.ToVector3(L, 4);
				obj.Load(mapid, navid, arg0);
			}
			else if (count == 3 && TypeChecker.CheckTypes(L, 1, typeof(Map2D), typeof(int), typeof(UnityEngine.Vector3)))
			{
				Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
				int mapid = (int)LuaDLL.lua_tonumber(L, 2);
				UnityEngine.Vector3 arg0 = ToLua.ToVector3(L, 3);
				obj.Load(mapid, mapid, arg0);
			}
				    

            return 0;
        }
        
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetTransfer(IntPtr L)
    {
        try
        {
            Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
            List<CLASSTAG_GridMapTransferData> list = obj.GetTransferList();
            LuaDLL.lua_newtable(L);
            for (int i = 0; i < list.Count; i++)
            {
                CLASSTAG_GridMapTransferData data = list[i];
                ToLua.Push(L, i + 1);
                LuaDLL.lua_newtable(L);

                ToLua.Push(L, 1);
                ToLua.Push(L, data.pos.x - data.size.x / 2);
                LuaDLL.lua_settable(L, -3);

                ToLua.Push(L, 2);
                ToLua.Push(L, data.pos.x + data.size.x / 2);
                LuaDLL.lua_settable(L, -3);

                ToLua.Push(L, 3);
                ToLua.Push(L, data.pos.y - data.size.y / 2);
                LuaDLL.lua_settable(L, -3);

                ToLua.Push(L, 4);
                ToLua.Push(L, data.pos.y + data.size.y / 2);
                LuaDLL.lua_settable(L, -3);

                LuaDLL.lua_settable(L, -3);

            }
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetTransferEffectParent(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 1);
            Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
            UnityEngine.GameObject o = obj.GetTransferEffectParent();
            ToLua.Push(L, o);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_Release(IntPtr L)
    {
        try
        {
            Map2D obj = (Map2D)ToLua.CheckObject(L, 1, typeof(Map2D));
            obj.FUNCTAG_Release();
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_get_width(IntPtr L)
    {
        object o = null;

        try
        {
            o = ToLua.ToObject(L, 1);
            Map2D obj = (Map2D)o;
            float ret = obj.width;
            LuaDLL.lua_pushnumber(L, ret);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index width on a nil value" : e.Message);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_get_height(IntPtr L)
    {
        object o = null;

        try
        {
            o = ToLua.ToObject(L, 1);
            Map2D obj = (Map2D)o;
            float ret = obj.height;
            LuaDLL.lua_pushnumber(L, ret);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index height on a nil value" : e.Message);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_get_xGrid(IntPtr L)
    {
        object o = null;

        try
        {
            o = ToLua.ToObject(L, 1);
            Map2D obj = (Map2D)o;
            int ret = obj.xTile;
            LuaDLL.lua_pushinteger(L, ret);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index xTile on a nil value" : e.Message);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_get_yGrid(IntPtr L)
    {
        object o = null;

        try
        {
            o = ToLua.ToObject(L, 1);
            Map2D obj = (Map2D)o;
            int ret = obj.yTile;
            LuaDLL.lua_pushinteger(L, ret);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index yTile on a nil value" : e.Message);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_get_gridPixel(IntPtr L)
    {
        object o = null;

        try
        {
            o = ToLua.ToObject(L, 1);
            Map2D obj = (Map2D)o;
            int ret = obj.gridPixel;
            LuaDLL.lua_pushinteger(L, ret);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index gridPixel on a nil value" : e.Message);
        }
    }

}

